using System;
using System.Net;
using System.Text;
using System.Net.NetworkInformation;
using NFSLibrary;
 
namespace NFShardlink
{
  class Program
   {
      static int timeout = 10;
      static bool useSecure = true;
      static NFSLibrary.NFSClient nfsClient;

     static int Main(string[] args)
      {

	int errors = 0;
	IPAddress ipAddress;
	if (args.Length != 4) {
	  Console.WriteLine("Usage: hardline ServerIP exportPath fromPath toPath");
	  Console.WriteLine(" fromPath and toPath use \\ separator");
	  return 10;
	}
	try {
	  ipAddress = IPAddress.Parse(args[0]);
	}
	catch (Exception e) {
	  Console.WriteLine("Failed to parse IP : " + e.Message);
	  return 1;
	}
	try {
	  NFSLibrary.NFSClient.NFSVersion ver = NFSLibrary.NFSClient.NFSVersion.v3;
	  nfsClient = new NFSLibrary.NFSClient(ver);
	  Encoding encoding = Encoding.ASCII;
	  //if (chkUseUnicode.Checked)
	  //    encoding = Encoding.UTF8;
	  nfsClient.Connect(ipAddress, 0, 0, (int) timeout * 1000, encoding, useSecure);
	}
	catch (Exception e) {
	  Console.WriteLine("Failed to access NFS server : " + e.Message);
	  return 2;
	}
	try {
	  nfsClient.MountDevice(args[1]);
	}
	catch (Exception e) {
	  Console.WriteLine("Failed to mount : " + e.Message);
	  errors = 3;
	}
	if (errors == 0) {
	  try {
	    nfsClient.Link(args[2], args[3]);
	  }
	  catch (Exception e) {
	    Console.WriteLine("Failed to create link : " + e.Message);
	    errors = 4;
	  }
	}
	try {
	  nfsClient.UnMountDevice();
	  nfsClient.Disconnect();
	}
	catch  {
	  // Ignore these errors
	}
	return errors;
      }
   }
}
